/* --------------------------------------------------------
    [T[oփANZXĎM[̈ꗗǂݎ

                                     2004/4/10
                                         S.Mio
*/
#include <stdio.h>
#include <winsock2.h>
#include "mimeconv.h"

/* -------------------------------------------------------- */
#define MAILLIST_STOP           0
#define MAILLIST_START          1
#define MAILLIST_INITWSA        2
#define MAILLIST_INITSOCK       3
#define MAILLIST_INITHOSTNAME   4
#define MAILLIST_SERVERACCCES   5
#define MAILLIST_OKWAIT         6
#define MAILLIST_LOGIN_USER     7
#define MAILLIST_LOGIN_PASS     8
#define MAILLIST_SERVERSTAT     9
#define MAILLIST_READHEADER     10
#define MAILLIST_SERVERQUIT     11
#define MAILLIST_SERVERCLOSE    12
#define MAILLIST_RECV           13
#define MAILLIST_RECVOK         14
#define MAILLIST_ERROR          15


/* -------------------------------------------------------- */
#define RECVBUF_LIMIT   (1024*8)

#define true            (1)
#define false           (0)


/* -------------------------------------------------------- */
/* T[o[ */
static char *servername      = "mbox.xxx.xx.jp";

/* |[gԍ */
static unsigned short portno = 110;

/* [U[ */
static char *username        = "username";

/* pX[h */
static char *passname        = "userpass";


/* -------------------------------------------------------- */
typedef struct listnode {
    int no;
    char *s;
    int size;
    struct listnode *next;
    struct listnode *back;
} t_listnode;

typedef struct {
    int callphase;
    int nextphase;
} t_phasecargo;

typedef struct {
    char *data;
    int count;
} t_recvcargo;


/* -------------------------------------------------------- */
static char recvbuf[RECVBUF_LIMIT];
static char subejctrecvbuf[RECVBUF_LIMIT];
static WSADATA wsadata;
static SOCKET sock;
static SOCKADDR_IN sockaddr;
static HOSTENT *host;
static int mailcount;
static t_listnode *rootlist = NULL;

void *setphasecargo(int phase, int nextphase);
void *setbackphase(int phase);
void nextphase(int phase, void *p);


/* -------------------------------------------------------- */
/* M */
void maillist_send(char *buf, int size)
{
    send(sock, buf, size, 0);
    printf("%s", buf);
}

/* M */
int maillist_recv(char *buf, int size)
{
    int recvcount;
    
    recvcount = recv(sock, buf, size, 0);
    if (recvcount) {
        buf[recvcount] = '\0';
        printf("%s", buf);
    }
    return recvcount;
}


/* -------------------------------------------------------- */
t_listnode *getlistend(void)
{
    t_listnode *list;

    if (rootlist == NULL)
        return NULL;
    
    list = rootlist;
    while (list->next != NULL)
        list = list->next;
    return list;
}

void addlist(int no, char *s, int size)
{
    t_listnode *list, *listend;
    
    list = (t_listnode *)malloc(sizeof(t_listnode));
    list->no = no;
    list->size = size;
    list->s = (char *)malloc(size);
    memcpy(list->s, s, size);
    list->next = NULL;

    listend = getlistend();
    if (listend == NULL) {
        rootlist = list;
        list->back = NULL;
    } else {
        listend->next = list;
        list->back = listend;
    }
}

void printlist(void)
{
    t_listnode *list;
    
    printf("\n--------------------------------------------\n");
    if (rootlist == NULL) {
        printf("[͂܂\n");
        return;
    }
    list = rootlist;
    do {
        printf("%04d: %s\n", list->no, list->s);
        list = list->next;
    } while(list != NULL);
}

void clearlist(void)
{
    t_listnode *list, *listend;
    
    listend = getlistend();
    if (listend == NULL)
        return;
    do {
        free(listend->s);
        list = listend->back;
        free(listend);
        listend = list;
    } while (listend != NULL);
}


/* -------------------------------------------------------- */
/* [ǂݎ̊Jn */
void maillist_start(int phase, void *p)
{
    printf("[̈ꗗǂݎ܂B\n");
    nextphase(MAILLIST_INITWSA, NULL);
}

/* WSȀ */
void maillist_init_wsa(int phase, void *p)
{
    int n;

    n = WSAStartup(MAKEWORD(1, 1), &wsadata);
    if (n != 0) {
        nextphase(MAILLIST_ERROR, setbackphase(phase));
        return;
    }
    nextphase(MAILLIST_INITSOCK, NULL);
}

/* \Pbg̏ */
void maillist_init_sock(int phase, void *p)
{
    sock = socket(PF_INET, SOCK_STREAM, 0);
    if (sock == INVALID_SOCKET) {
        nextphase(MAILLIST_ERROR, setbackphase(phase));
        return;
    }
    nextphase(MAILLIST_INITHOSTNAME, NULL);
}

/* zXg̕ϊ */
void maillist_init_hostname(int phase, void *p)
{
    host = gethostbyname(servername);
    if (host == NULL) {
        nextphase(MAILLIST_ERROR, setbackphase(phase));
        return;
    }

    memset(&sockaddr, 0, sizeof(SOCKADDR_IN));
    sockaddr.sin_family = AF_INET;
    sockaddr.sin_port = htons(portno);
    sockaddr.sin_addr = *((LPIN_ADDR)*host->h_addr_list);
    nextphase(MAILLIST_SERVERACCCES, NULL);
}

/* T[oւ̃ANZX */
void maillist_serveraccces(int phase, void *p)
{
    int handle;

    handle = connect(sock, (PSOCKADDR)&sockaddr, sizeof(sockaddr));
    if (handle != 0) {
        nextphase(MAILLIST_ERROR, setbackphase(phase));
        return;
    }
    nextphase(MAILLIST_OKWAIT, NULL);
}

/* T[o+OKԂ̂҂ */
void maillist_okwait(int phase, void *p)
{
    int recvcount;
    
    if (p == NULL) {
        nextphase(MAILLIST_RECVOK, setbackphase(phase));
    } else {
        nextphase(MAILLIST_LOGIN_USER, NULL);
    }
}

/* OC:[U[̓ */
void maillist_login_user(int phase, void *p)
{
    char s[256];
    int recvcount;
    
    if (p == NULL) {
        sprintf(s, "USER %s\r\n", username);
        maillist_send(s, strlen(s));
        nextphase(MAILLIST_RECVOK, setbackphase(phase));
    } else {
        nextphase(MAILLIST_LOGIN_PASS, NULL);
    }
}

/* OC:pX[h̓ */
void maillist_login_pass(int phase, void *p)
{
    char s[256];
    int recvcount;

    if (p == NULL) {
        sprintf(s, "PASS %s\r\n", passname);
        maillist_send(s, strlen(s));
        nextphase(MAILLIST_RECVOK, setbackphase(phase));
    } else {
        nextphase(MAILLIST_SERVERSTAT, NULL);
    }
}

/* Xe[^X烁[Mǂ݂Ƃ */
void maillist_serverstat(int phase, void *p)
{
    char *s = "STAT\r\n";
    char *nostart;
    t_recvcargo *recvcargo;
    int recvcount;

    if (p == NULL) {
        maillist_send(s, strlen(s));
        nextphase(MAILLIST_RECVOK, setbackphase(phase));
    } else {
        recvcargo = (t_recvcargo *)p;
        nostart = strchr(recvcargo->data, ' ');
        if (nostart != NULL) {
            nostart++;
            mailcount = atoi(nostart);
            if (mailcount == 0)
                nextphase(MAILLIST_SERVERQUIT, NULL);
            else
                nextphase(MAILLIST_READHEADER, NULL);
        }
    }
}

/* [wb_Subject荞         */
/* Subject̓eׂĂfR[h */
void maillist_readsubject(char *src)
{
    char *subjectid = "Subject: ";
    char *s, *start, *dest;
    static int subjectreadflag = false;
    static char *mimecode = NULL;
    static int mimecode_count;
    int count, oldc;
    
    /* SubjectW */
    if (!subjectreadflag) {
        start = strstr(src, subjectid);
        if (start != NULL) {
            subjectreadflag = true;
            start += strlen(subjectid);
            mimecode = NULL;
            mimecode_count = 0;
        }
    } else {
        start = src;
    }
    
    if (!subjectreadflag)
        return;
    /* ǂݍ */
    count = 0;
    oldc = 0;
    s = start;
    while(*s) {
        if ((oldc == '\n') && (*s != ' ') && (*s != '\t')) {
            subjectreadflag = false;
            if (count >= 2)
                count -= 2;
            break;
        }
        oldc = *s;
        s++;
        count++;
    }
    if (count) {
        if (mimecode != NULL) {
            mimecode_count += count;
            mimecode = (char *)realloc(mimecode, mimecode_count + 2);
            strncat(mimecode, start, count);
            mimecode[mimecode_count] = '\0';
        } else {
            mimecode = (char *)malloc(count + 2);
            mimecode_count = count;
            strncpy(mimecode, start, count);
            mimecode[count] = '\0';
        }

        if (subjectreadflag == false) {
            dest = (char *)malloc(mimecode_count + 1);
            mime_decode(dest, mimecode);
            addlist(mailcount, dest, strlen(dest) + 1);
            free(mimecode);
            free(dest);
        }
    }
}

/* e[wb_ǂݎ */
void maillist_readheader(int phase, void *p)
{
    char s[256];
    t_recvcargo *recvcargo;
    static char *checkstr = ".\r\n";
    static char *checkp, *recvp;
    int recvcount;

    if (p == NULL) {
        if (mailcount == 0) {
            nextphase(MAILLIST_SERVERQUIT, NULL);
            return;
        }
        sprintf(s, "TOP %d 0\r\n", mailcount--);
        maillist_send(s, strlen(s));
        nextphase(MAILLIST_RECVOK, setbackphase(phase));
        checkp = checkstr;
    } else {
        recvcargo = (t_recvcargo *)p;
        maillist_readsubject(recvcargo->data);
        recvp = recvcargo->data;
        while (*recvp) {
            if (*checkp == *recvp)
                checkp++;
            else
                checkp = checkstr;
            if (*checkp == '\0')
                break;
            recvp++;
        }
        
        if (*checkp == '\0') {
             nextphase(MAILLIST_READHEADER, NULL);
        } else {
             nextphase(MAILLIST_RECV, setbackphase(phase));
        }
    }
}

/* T[oƂ̐ڑؒf */
void maillist_serverquit(int phase, void *p)
{
    char *s = "QUIT\r\n";
    
    if (p == NULL) {
        maillist_send(s, strlen(s));
        nextphase(MAILLIST_RECVOK, setbackphase(phase));
    } else {
        nextphase(MAILLIST_SERVERCLOSE, NULL);
    }
}

/* ڑN[Y */
void maillist_serverclose(int phase, void *p)
{
    closesocket(sock);
    WSACleanup();
    nextphase(MAILLIST_STOP, NULL);
}

/* +OK܂ŎM */
void maillist_recvokdata(int phase, void *p)
{
    int backphase = *(int *)p;
    static t_recvcargo recvcargo;
    static char ringbuf[RECVBUF_LIMIT];
    static int ringbufcount = 0;
    static int ringbufhead = 0;
    static int ringbuftail = 0;
    int ringbufrecvsize = 4;
    int recvcount, ringbufcopysize, copycount;
    char *s;

    
    recvcount = maillist_recv(ringbuf + ringbuftail, ringbufrecvsize);
    if (recvcount) {
        ringbuftail += recvcount;
        if ((ringbuftail + ringbufrecvsize) >= RECVBUF_LIMIT)
            ringbuftail = 0;
        if (ringbufhead >= ringbuftail) {
            ringbufhead = ringbuftail + 1;
            if (ringbufhead >= RECVBUF_LIMIT)
                ringbufhead = 0;
        }

        if (ringbufhead <= ringbuftail) {
            ringbufcopysize = ringbuftail - ringbufhead;
            strncpy(recvbuf, ringbuf + ringbufhead, ringbufcopysize);
            recvbuf[ringbufcopysize] = '\0';
        } else {
            ringbufcopysize = RECVBUF_LIMIT - ringbufhead;
            strncpy(recvbuf, ringbuf + ringbufhead, ringbufcopysize);
            strncpy(recvbuf + ringbufcopysize, ringbuf, ringbuftail);
            recvbuf[ringbufcopysize + ringbuftail] = '\0';
        }

        s = strstr(recvbuf, "+OK");
        if ((s != NULL) && (strchr(s, '\n') != NULL)) {
            recvcargo.data  = recvbuf;
            recvcargo.count = recvcount;
            
            ringbufcount = 0;
            ringbufhead = 0;
            ringbuftail = 0;
            
            nextphase(backphase, &recvcargo);
        }
    }
}

/* f[^M */
void maillist_recvdata(int phase, void *p)
{
    int backphase = *(int *)p;
    static t_recvcargo recvcargo;
    int recvcount;
    
    recvcount = maillist_recv(recvbuf, RECVBUF_LIMIT);
    recvcargo.data  = recvbuf;
    recvcargo.count = recvcount;
    nextphase(backphase, &recvcargo);
}

/* G[ */
void maillist_servererror(int phase, void *p)
{
    int backphase = *(int *)p;
    
    printf("Phase %dŃG[N܂\n", backphase);
    if (backphase >= MAILLIST_INITSOCK)
        closesocket(sock);
    if (backphase >= MAILLIST_INITWSA)
        WSACleanup();
    nextphase(MAILLIST_STOP, NULL);
}


/* -------------------------------------------------------- */
/* tF[Y֘A */
static int phaseno;
static void *phasedata;
typedef void (*t_phasefunc)(int phase, void *p);
t_phasefunc funclist[] = {
    NULL,
    maillist_start,
    maillist_init_wsa,
    maillist_init_sock,
    maillist_init_hostname,
    maillist_serveraccces,
    maillist_okwait,
    maillist_login_user,
    maillist_login_pass,
    maillist_serverstat,
    maillist_readheader,
    maillist_serverquit,
    maillist_serverclose,
    maillist_recvdata,
    maillist_recvokdata,
    maillist_servererror,
};

/* ÕtF[Yݒ */
void *setbackphase(int phase)
{
    static int backphase = 0;

    backphase = phase;
    return &backphase;
}

/* ̃tF[Yݒ */
void nextphase(int phase, void *p)
{
    phaseno = phase;
    phasedata = p;
}

/* tF[Ys */
int executephase(void)
{
    if (phaseno == 0)
        return FALSE;
    funclist[phaseno](phaseno, phasedata);
    return TRUE;
}


/* -------------------------------------------------------- */
int main(void)
{
    nextphase(MAILLIST_START, NULL);
    while (executephase())
        ;

    printlist();
    clearlist();

    return 0;
}
