/* --------------------------------------------------------
   MIMER[h̕ϊ
   BASE64  JIS -> Shift JISւ̕ϊ

                                     2004/4/10
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mimeconv.h"


/* -------------------------------------------------------- */
#define true            (1)
#define false           (0)


/* -------------------------------------------------------- */
/* BASE64ɎgLN^->lւ̕ϊ */
int base64_convchar(char c)
{
    if (c == '/')
        return 63;
    if (c == '+')
        return 62;
    if ((c >= '0') && (c <= '9'))
        return (c - '0') + 52;
    if ((c >= 'a') && (c <= 'z'))
        return (c - 'a') + 26;
    if ((c >= 'A') && (c <= 'Z'))
        return (c - 'A');
    return 0;
}

/* BASE64̃fR[h */
int base64_decode(char *dest, char *src)
{
    char *p;
    int c, i, buf, count;

    count = 0;
    while (*src) {
        buf = 0;
        for (i = 0; i < 4; i++)
            buf = (buf << 6) | base64_convchar(*src++);

        p = (char *)&buf;

        /* oCgtɂ */
        for (i = 0; i < 3; i++)
            dest[i] = p[2 - i];

        dest += 3;
        count += 3;
    }
    *dest = '\0';
    return count;
}

/* -------------------------------------------------------- */
/* Quoted-PrintablẽfR[h */
int quoted_decode(char *dest, char *src)
{
    char *p;
    int count;
    char buf[2+1];

    count = 0;
    while (*src) {
        if (*src == '=') {
            src++;
            strncpy(buf, src, 2);
            *dest = (char)strtol(buf, NULL, 16);
            src += 2;
        } else {
            *dest = *src;
            src++;
        }
        dest++;
        count++;
    }
    *dest = '\0';
    return count;
}


/* -------------------------------------------------------- */
#define ESC (0x1b)

/* JISR[hVtg */
void jisshift(int *h, int *l)
{
    if (*h & 1) {
        *l += (*l < 0x60) ? 0x1f : 0x20;
    } else {
        *l += 0x7e;
    }
    if (*h < 0x5f) {
        *h = (*h + 0xe1) >> 1;
    } else {
        *h = (*h + 0x161) >> 1;
    }
}

/* JISR[h -> Shift JISR[h ȈՔ */
int jis2sjis(char *dest, char *src)
{
    int kanjiarea = false;
    int h, l, count;

    count = 0;
    while (*src) {
        if (*src == ESC) {
            if ((src[1] == '$') && ((src[2] == 'B') || (src[2] == '@'))) {
                kanjiarea = true;
                src += 3;
                continue;
            }
            if ((src[1] == '(') && ((src[2] == 'B') || (src[2] == 'J'))) {
                kanjiarea = false;
                src += 3;
                continue;
            }
        }
        if ((kanjiarea) &&
            (*src >= 0x21) && (*src <= 0x7e)) {
            h = src[0];
            l = src[1];
            jisshift(&h, &l);
            dest[0] = h;
            dest[1] = l;
            src += 2;
            dest += 2;
            count += 2;
            continue;
        }
        *dest = *src;
        dest++;
        src++;
        count++;
    }
    *dest = '\0';
    return count;
}


/* -------------------------------------------------------- */
#define CHARSET_ISO2022 (0)
#define CHARSET_SJIS    (1)
#define CHARSET_USASCII (2)
#define CHARSET_LIMIT   (3)
static char *codeheadtable[] = {
    "=?ISO-2022-JP?",
    "=?Shift_JIS?",
    "=?US-ASCII?",
};
static char *codetail = "?=";

/* w肳ꂽ񂪓oꂷ܂ł̕Ԃ */
int mime_getstartcount(char *src, char *header)
{
    int count;
    char *checkp;

    count = 0;
    checkp = header;
    while(*src) {
        if (tolower(*src) == tolower(*checkp)) {
            checkp++;
            if (*checkp == '\0') {
                return (count + 1) - strlen(header);
            }
        } else {
            checkp = header;
        }
        if (*src == '\n')
            return -1;
        src++;
        count++;
    }
    return -1;
}

/* Xy[XȂǃfR[hɕKv̂ȂԂ */
int mime_getskipcount(char *src)
{
    int count;

    count = 0;
    while(*src) {
        if ((*src != ' ')  && (*src != '\t') &&
            (*src != '\r') && (*src != '\n')) {
            return count;
        }
        src++;
        count++;
    }
    return 0;
}

/* fR[hɕKv̂Ȃ΂܂ł̕ɂ */
char *mime_cuttail(char *src)
{
    char *s;

    s = src;
    while(*s) {
        if ((*s == '\t') || (*s == '\r') || (*s== '\n')) {
            *s = '\0';
            return src;
        }
        s++;
    }
    return src;
}

/* MIMẼfR[h */
int mime_decode(char *dest, char *src)
{
    char *codebuf, *jisbuf, *jisbufp, *origdest, *codehead;
    int iscodearea, isBASE64;
    int copycount, copycountlow, skipcount, jiscount, i, ischaerset;

    codebuf = (char *)malloc(strlen(src) + 1);
    jisbuf = (char *)malloc((strlen(src) + 1) * 3);

    iscodearea = false;
    jisbufp = jisbuf;
    origdest = dest;
    *jisbuf = '\0';
    while (*src) {
        if (!iscodearea) {
            /* R[hn܂܂ł̕𓾂 */
            copycountlow = -1;
            for (i = 0; i < CHARSET_LIMIT; i++) {
                copycount = mime_getstartcount(src, codeheadtable[i]);
                if ((copycount != -1) && 
                   ((copycountlow == -1) || (copycountlow >= copycount))) {
                    ischaerset = i;
                    copycountlow = copycount;
                    codehead = codeheadtable[i];
                }
            }
            copycount = copycountlow;
            skipcount = mime_getskipcount(src);

            if (copycount == skipcount) {
                /* Kv̂ȂƃR[h܂ł̕Ȃ */
                /* ̊Ԃ̕Rs[Ȃ */
                copycount = 0;
            } else if (copycount == -1) {
                /* R[hȂƂCR/LF܂ŕRs[ */
                if (skipcount) {
                    copycount = 0;
                } else {
                    copycount = mime_getstartcount(src, "\r\n");
                    if(copycount == -1)
                        copycount = strlen(src);
                    else
                        copycount += 2;
                }
                codehead = NULL;
            }
        } else {
            if (strlen(src) <= strlen(codehead) + 2)
                break;
            src += strlen(codehead);
            if ((*src == 'Q') || (*src == 'q')) {
                isBASE64 = false;
            } else {
                isBASE64 = true;
            }
            src += 2;
            copycount = mime_getstartcount(src, codetail);
            if (copycount != -1) {
                skipcount = copycount + strlen(codetail);
            } else {
                copycount = strlen(src);
                skipcount = copycount;
            }
        }
        
        if (!iscodearea) {
            if (copycount) {
                if (jisbuf != jisbufp) {
                    if (ischaerset == CHARSET_ISO2022) {
                        jiscount = jis2sjis(dest, jisbuf);
                    } else {
                        strcpy(dest, jisbuf);
                        jiscount = strlen(jisbuf);
                        dest[jiscount] = '\0';
                    }
                    jisbufp = jisbuf;
                    dest += jiscount;
                }

                strncpy(dest, src, copycount);
                dest[copycount] = '\0';

                mime_cuttail(dest);
                src += copycount;
                
                while(*dest)
                   dest++;
            } else {
                src += skipcount;
            }
            if (codehead != NULL)
                iscodearea = true;
        } else {
            strncpy(codebuf, src, copycount);
            codebuf[copycount] = '\0';

            if (isBASE64) {
                base64_decode(jisbufp, codebuf);
            } else {
                quoted_decode(jisbufp, codebuf);
            }

            while(*jisbufp)
               jisbufp++;

            src += skipcount;
            iscodearea = false;
        }
    }

    if (jisbuf != jisbufp) {
        if (ischaerset == CHARSET_ISO2022) {
            jis2sjis(dest, jisbuf);
        } else {
            strcpy(dest, jisbuf);
        }
    }
    free(codebuf);
    free(jisbuf);
    return strlen(origdest);
}
